## facile 1.1

=== Makefile ===
# $Id: release_Makefile,v 1.7 2003/05/15 09:13:16 brisset Exp $

include config_Makefile

compile:
	cd src; make

install:
	if test -d $(FACILEDIR); then : ; else mkdir $(FACILEDIR); fi
	cp src/facile.cmi src/facile.cma src/facile.cmxa src/facile.a $(FACILEDIR)
	chmod a+r $(FACILEDIR)/facile.cmi
	chmod a+r $(FACILEDIR)/facile.cma
	chmod a+r $(FACILEDIR)/facile.cmxa
	chmod a+r $(FACILEDIR)/facile.a

clean:
	cd src; make clean

distclean uninstall:
	rm -fr $(FACILEDIR)

check:
	cd examples; make FACILEDIR=../src queens.opt; ./queens.opt 8

=== src/Makefile ===
# $Id: Makefile,v 1.73 2004/09/01 12:33:49 barnier Exp $

OCAMLC = ocamlc.opt -g
OCAMLMLI = ocamlc.opt
OCAMLOPT = ocamlopt -unsafe -noassert -inline 10
OCAMLDEP = ocamldep
INCLUDES =
OPTOPT = 
OCAMLLIB := $(shell echo `ocamlc -where`)
FACILELIB = $(OCAMLLIB)/facile

CSTR= fcl_debug.ml fcl_misc.ml fcl_domain.ml fcl_setDomain.ml fcl_float.ml fcl_stak.ml fcl_data.ml fcl_cstr.ml fcl_var.ml fcl_invariant.ml fcl_reify.ml fcl_boolean.ml fcl_linear.ml fcl_nonlinear.ml fcl_expr.ml fcl_arith.ml fcl_conjunto.ml fcl_goals.ml fcl_fdArray.ml fcl_gcc.ml fcl_opti.ml fcl_alldiff.ml fcl_sorting.ml fcl_interval.ml fcl_genesis.ml facile.ml
# fcl_binary.ml fcl_ac6.ml

CSTRCMO = $(CSTR:.ml=.cmo)
CSTRCMX = $(CSTR:.ml=.cmx)

# Default target: libraries and toplevel
all : facile.cma facile.cmxa facile

# Libraries
facile.cma : $(CSTRCMO)
	$(OCAMLC) -o $@ -a $(CSTRCMO)

facile.cmxa : $(CSTRCMX)
	$(OCAMLOPT) -o $@ -a $(CSTRCMX)

# Version of the library to be linked with the -p (profiler) option
facile.p.cmxa : $(CSTR)
	rm -fr $(CSTRCMX)
	make facile.cmxa OPTOPT=-p
	rm -fr $(CSTRCMX)
	mv facile.cmxa $@
	mv facile.a facile.p.a

# Toplevel (to be run with the "-I +facile" option)
facile : facile.cma
	ocamlmktop -o $@ facile.cma

# Experimental: to get inlining of functors using preprocessing:
# Does not work with many modules (e.g. containing class expressions
facile.exp.cmxa : $(CSTR)
	rm -fr $(CSTRCMX)
	make fcl_stak.cmx fcl_cstr.cmx fcl_inv.cmx fcl_reify.cmx fcl_arith.cmx fcl_goals.cmx fcl_fdArray.cmx fcl_gcc.cmx fcl_alldiff.cmx fcl_sorting.cmx fcl_interval.cmx facile.cmx
	make facile.cmxa OPTOPT="-pp inline_functors"
	rm -fr $(CSTRCMX)
	mv facile.cmxa $@
	mv facile.a facile.exp.a

.SUFFIXES:
.SUFFIXES: .ml .mli .mly .mll .cmi .cmo .cmx .p.cmx .s

.ml.cmo :
	$(OCAMLC) $(INCLUDES) $(INCLUDES) -c $<
.mli.cmi :
	$(OCAMLMLI) $(INCLUDES) -c $<
.ml.cmx :
	$(OCAMLOPT) $(OPTOPT) $(INCLUDES) -c $<
.ml.s :
	$(OCAMLOPT) $(OPTOPT) $(INCLUDES) -S -c $<
.mly.ml :
	ocamlyacc $<
.mll.ml :
	ocamllex $<

clean:
	\rm -f *.cm* *.annot *.o *.a *~ .depend facile

.depend:
	$(OCAMLDEP) $(INCLUDES) *.mli *.ml > $@

include .depend

=== debian/changelog ===
facile (1.1-9build1) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 12:10:26 +0000

facile (1.1-9) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * Fix compilation with OCaml 4.01.0 (Closes: #731218)
  * Remove myself from Uploaders
  * Update Vcs-*

  [ Mehdi Dogguy ]
  * Remove myself from Uploaders.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Dec 2013 09:26:26 +0100

facile (1.1-8) unstable; urgency=low

  * debian/control:
    - update Vcs-* to point to git repository
    - remove duplicate section field
    - add suggestion to ocaml-findlib
    - bump Standards-Version to 3.9.2 (no changes)
  * Switch source package format to 3.0 (quilt)
  * Bump debhelper compat level to 8

 -- Stéphane Glondu <glondu@debian.org>  Wed, 17 Aug 2011 21:49:35 +0200

facile (1.1-7) unstable; urgency=low

  [ Stéphane Glondu ]
  * Acknowledge non-maintainer uploads
  * Switch packaging to git
  * Remove Steffen and add myself to Uploaders
  * Bump debhelper compatibility level to 7
  * Remove versioned dependencies available in oldstable
  * Switch copyright to machine-parsable format
  * Add Homepage
  * Move to new ocaml section
  * Fix typography of Objective Caml in description

  [ Mehdi Dogguy ]
  * Add myself to uploaders
  * Build-depend on ocaml (>= 3.11.1-3~) and dh-ocaml (>= 0.9~)
  * Use new features of dh-ocaml 0.9
  * Bump Standards-Version to 3.8.3
    + add a README.source
  * Move libfacile-ocaml-dev to section ocaml
  * Add a META for libfacile-ocaml-dev (Closes: #443005)

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 06 Oct 2009 13:22:47 +0200

facile (1.1-6.3) unstable; urgency=low

  * Call clean in examples/ manually as upstream's Makefile wont and cdbs
    doesn't keep the patches applied when cleaning.
  * Fix ocamlopt usage; closes: #501672.
    - New dpatch, 30-non-opt-check, ocamlopt isn't available on all arches;
      don't use it for make check.
    - New patch, 40-allow-ocamlc-override-in-examples, allow overriding OCAMLC
      in examples by using separate _INVOKE vars to run misc commands.

 -- Loic Minier <lool@dooz.org>  Thu, 09 Oct 2008 15:20:00 +0200

facile (1.1-6.2) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir

  [ Loic Minier ]
  * Non-maintainer upload to fix misc packaging bugs; closes: #500830.
  * Only compute OCAML_ABI once by using := instead of =.
  * Don't overwrite DEB_DH_GENCONTROL_ARGS and use -u instead of -- to pass
    args to dpkg-gencontrol in a safer manner.
  * Include dpatch.mk instead of calling dpatch manually; NB: this will cause
    the patches to be applied before running configure which is more useful,
    but doesn't change anything with the current patches; bump up cdbs bdep to
    >= 0.4.21.
  * Use the makefile.mk cdbs class instead of the autotools one.
    - Move the configure flag to a new custom common-configure-impl /
      config_Makefile rule.
    - Drop --disable-maintainer-mode exclusion hack.
    - Don't call make clean in clean; cdbs does that for us.
    - Set DEB_MAKE_INSTALL_TARGET to install.
  * Drop redundant setting of FACILEDIR with the echo >config_Makefile
    construct; the configure flag works fine.
  * Replace debian/libfacile-ocaml-dev.dirs.in template and logic with
    DEB_INSTALL_DIRS_ALL; fixes lack of cleanup of
    debian/libfacile-ocaml-dev.dirs.
  * Set OCAMLC OCAMLMLI via DEB_MAKE_INVOKE instead of DEB_MAKE_BUILD_TARGET;
    this sets the same environment for all make runs.
  * Add year 2004 to copyright.
  * Point at common-licenses for the full text of the LGPL and include the
    full licensing header.
  * Depend on ${misc:Depends} as recommended in debhelper 5.
  * Set DEB_MAKE_CHECK_TARGET to check to run the testsuite during package
    build.
  * Use Vcs-* headers instead of XS-Vcs-*.
  * Bump up Standards-Version to 3.8.0.
  * Provide examples/*.ml and examples/*.dat as examples; closes: #446804.

 -- Loic Minier <lool@dooz.org>  Thu, 02 Oct 2008 12:37:48 +0200

facile (1.1-6.1) unstable; urgency=low

  * Non-maintainer upload.
  * Rebuilding against ocaml 3.10 (closes: #442997)

 -- Stefano Zacchiroli <zack@debian.org>  Tue, 18 Sep 2007 09:34:40 +0200

facile (1.1-6) unstable; urgency=low

  * Bump debhelper level to 5
  * Change my maintainer address

 -- Steffen Joeris <white@debian.org>  Wed,  3 Jan 2007 22:16:17 +0100

facile (1.1-5) unstable; urgency=low

  * Rebuild with OCaml 3.09.2
  * Bump standard version to 3.7.2
  * Remove control.in as we no longer have a need for that

 -- Steffen Joeris <steffen.joeris@skolelinux.de>  Wed, 17 May 2006 22:55:21 +0200

facile (1.1-4) unstable; urgency=low

  * Make sure that the *.mli files are installed before
    the *.cmi files (Closes: #352008)

 -- Steffen Joeris <steffen.joeris@skolelinux.de>  Thu,  9 Feb 2006 12:52:11 +0100

facile (1.1-3) unstable; urgency=low

  * Rebuild with OCaml 3.09.1
  * Add control.in which is only called manually 
    with a special rule and not during the build

 -- Steffen Joeris <steffen.joeris@skolelinux.de>  Sun,  8 Jan 2006 18:51:12 +0100

facile (1.1-2) unstable; urgency=low

  * Adapt patch to upstream Makefile to not try to build the native library
    when ocamlopt isn't available (Closes: #340305).
    Thanks to Julien Cristau

 -- Steffen Joeris <steffen.joeris@skolelinux.de>  Tue, 22 Nov 2005 19:18:05 +0100

facile (1.1-1) unstable; urgency=low

  * Initial release (Closes: #336852)

 -- Steffen Joeris <steffen.joeris@skolelinux.de>  Sun, 30 Oct 2005 00:41:20 +0200

=== debian/control ===
Source: facile
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 8),
 cdbs,
 ocaml-nox (>= 3.11.1-3~),
 dh-ocaml (>= 0.9~)
Standards-Version: 3.9.2
Section: ocaml
Homepage: http://www.recherche.enac.fr/opti/facile/
Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/facile.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/facile.git

Package: libfacile-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 ${ocaml:Provides}
Suggests: ocaml-findlib
Description: functional constraint library implemented in Objective Caml
 FaCiLe is a constraint programming library over integer finite domain
 written in Objective Caml. It offers all usual facilities to create
 and manipulate finite domain variables, arithmetic expressions and
 constraints (possibly non-linear), built-in global constraints and
 search goals. FaCiLe allows as well to build easily user-defined
 constraints and goals (including recursive ones), making pervasive use
 of OCaml higher-order functionals to provide a simple and flexible
 interface for the user. As FaCiLe is an OCaml library and not "yet
 another language", the user benefits from type inference and strong
 typing discipline, high level of abstraction, modules and objects
 system, as well as native code compilation efficiency, garbage
 collection and replay debugger, all features of OCaml (among many
 others) that allow to prototype and experiment quickly: modeling, data
 processing and interface are implemented with the same powerful and
 efficient language.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/ocaml.mk

FACILEDIR := $(shell ocamlc -where)/facile
VERSION := $(shell head -n1 debian/changelog | awk -F'[ ()-]+' '{print $$2}')
DEB_INSTALL_DIRS_ALL += $(FACILEDIR)
DEB_MAKE_INVOKE += OCAMLC="ocamlc -g" OCAMLMLI=ocamlc
DEB_MAKE_INSTALL_TARGET := install
DEB_MAKE_CHECK_TARGET := check

common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: config_Makefile
config_Makefile:
	./configure --faciledir debian/libfacile-ocaml-dev/$(FACILEDIR)
	sed 's/@VERSION@/$(VERSION)/' debian/META.in > $(CURDIR)/META

clean::
	rm -f META
	# not cleaned upstream
	rm -f config_Makefile
	$(DEB_MAKE_INVOKE) -k -C examples clean

=== debian/watch ===
version=3
http://www.recherche.enac.fr/opti/facile/distrib/ \
        facile-([\d.]+).tar.gz

## facile 1.1.1

=== examples/Makefile ===
# $Id: Makefile.facile,v 1.2 2003/08/06 14:01:31 brisset Exp $

# Generic Makefile for single files using FaCiLe. Allow to produce
# file.out (ocamlc) and file.opt (ocamlopt) from file.ml while linking
# with the FaCiLe library

FACILEDIR= +facile
INCLUDES= -I $(FACILEDIR)

OCAMLC= ocamlc -g $(INCLUDES)
OCAMLMLI= ocamlc $(INCLUDES)
OCAMLOPT= ocamlopt $(INCLUDES)
OCAMLDEP= ocamldep $(INCLUDES)

.SUFFIXES:
.SUFFIXES: .ml .mli .mly .mll .cmi .cmo .cmx .out .opt .p.cmx .popt

.ml.cmo :
	$(OCAMLC) -c $<
.mli.cmi :
	$(OCAMLMLI) -c $<
.ml.cmx :
	$(OCAMLOPT) -c $<
# To produce profiled objects
.ml.p.cmx :
	$(OCAMLOPT) -p -c $<
	mv $*.cmx $@
	mv $*.o $*.p.o
.cmo.out :
	$(OCAMLC) -o $@ facile.cma $<
# To produce profiled binaries
.p.cmx.popt :
	$(OCAMLOPT) -p -o $@ facile.p.cmxa $<
.cmx.opt :
	$(OCAMLOPT) -o $@ facile.cmxa $<
.mly.ml :
	ocamlyacc $<
.mll.ml :
	ocamllex $<

clean:
	\rm -f *.cmo *.cmi *.cmx *.o *~ *.opt *.out .depend *.popt

.depend:
	$(OCAMLDEP) *.mli *.ml > $@

include .depend

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # $Id: Makefile,v 1.73 2004/09/01 12:33:49 barnier Exp $
 
-OCAMLC = ocamlc.opt -g
-OCAMLMLI = ocamlc.opt
+OCAMLC = ocamlc -g
+OCAMLMLI = ocamlc
 OCAMLOPT = ocamlopt -unsafe -noassert -inline 10
 OCAMLDEP = ocamldep
 INCLUDES =

=== debian/changelog ===
facile (1.1.1-1build3) focal; urgency=medium

  * No change rebuild against new ocaml ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Feb 2020 22:43:17 +0000

facile (1.1.1-1build2) bionic; urgency=high

  * No change rebuild against ocaml 4.05.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Oct 2017 23:54:38 +0100

facile (1.1.1-1build1) artful; urgency=high

  * No change rebuild against ocaml 4.04 transition.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 26 Jun 2017 22:48:34 +0100

facile (1.1.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refresh patches
    - Remove 0005-Fix-compilation-with-OCaml-4.01.0.patch, integrated
      upstream.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2016 23:03:10 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: facile
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Build-Depends:
  debhelper (>= 8),
  cdbs,

## facile 1.1.3

=== debian/changelog ===
facile (1.1.3-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Update Vcs-* to point to salsa
  * Update debian/watch and Homepage
  * Bump debhelper compat level to 13 (and drop cdbs)
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Aug 2020 07:20:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: facile
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Build-Depends:
- debhelper (>= 8),
- cdbs,
- ocaml-nox (>= 3.11.1-3~),
- dh-ocaml (>= 0.9~)
-Standards-Version: 3.9.2
+ debhelper-compat (= 13),
+ ocaml-nox,
+ dh-ocaml
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Section: ocaml
-Homepage: http://www.recherche.enac.fr/opti/facile/
-Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/facile.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/facile.git
+Homepage: http://facile.recherche.enac.fr/
+Vcs-Git: https://salsa.debian.org/ocaml-team/facile.git
+Vcs-Browser: https://salsa.debian.org/ocaml-team/facile
 
 Package: libfacile-ocaml-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

FACILEDIR := $(shell ocamlc -where)/facile
VERSION := $(shell head -n1 debian/changelog | awk -F'[ ()-]+' '{print $$2}')

%:
	dh $@ --with ocaml

override_dh_auto_configure:
	./configure --faciledir debian/libfacile-ocaml-dev/$(FACILEDIR)
	sed 's/@VERSION@/$(VERSION)/' debian/META.in > $(CURDIR)/META

override_dh_auto_build:
	$(MAKE) OCAMLC="ocamlc -g" OCAMLMLI=ocamlc

override_dh_auto_install:
	mkdir -p debian/libfacile-ocaml-dev/$(FACILEDIR)
	dh_auto_install

override_dh_auto_clean:
	$(MAKE) -C src clean
	rm -f META
	# not cleaned upstream
	rm -f config_Makefile
	$(MAKE) -k -C examples clean

=== debian/watch ===
version=3
http://facile.recherche.enac.fr/distrib/ \
        facile-([\d.]+).tar.gz

## facile 1.1.4

=== debian/changelog ===
facile (1.1.4-1build1) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:20:32 +0100

facile (1.1.4-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Bump Standards-Version to 4.6.0
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Mon, 29 Nov 2021 13:51:50 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,9 @@
 Build-Depends:
  debhelper-compat (= 13),
  ocaml-nox,
+ ocaml-dune,
  dh-ocaml
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Section: ocaml
 Homepage: http://facile.recherche.enac.fr/

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

DESTDIR=$(CURDIR)/debian/tmp

%:
	dh $@ --with ocaml

override_dh_auto_build:
	dune build -p facile

override_dh_auto_install:
	dune install --destdir=$(DESTDIR) --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)

override_dh_auto_test:
	dune runtest -p facile
